package repository

import (
	"fmt"
	"strings"
	"time"

	"nms_nbi/src/framework/datasource"
	"nms_nbi/src/framework/logger"
	"nms_nbi/src/framework/utils/parse"
	"nms_nbi/src/framework/utils/repo"
	"nms_nbi/src/modules/network_element/model"
)

// 实例化数据层 NewNeHostCmdImpl 结构体
var NewNeHostCmdImpl = &NeHostCmdImpl{
	selectSql: `select 
	cmd_id, cmd_type, group_id, title, command, remark, create_by, create_time, update_by, update_time
	from ne_host_cmd`,

	resultMap: map[string]string{
		"cmd_id":      "CmdID",
		"cmd_type":    "CmdType",
		"group_id":    "GroupID",
		"title":       "Title",
		"command":     "Command",
		"remark":      "Remark",
		"create_by":   "CreateBy",
		"create_time": "CreateTime",
		"update_by":   "UpdateBy",
		"update_time": "UpdateTime",
	},
}

// NeHostCmdImpl 网元主机连接 数据层处理
type NeHostCmdImpl struct {
	// 查询视图对象SQL
	selectSql string
	// 结果字段与实体映射
	resultMap map[string]string
}

// convertResultRows 将结果记录转实体结果组
func (r *NeHostCmdImpl) convertResultRows(rows []map[string]any) []model.NeHostCmd {
	arr := make([]model.NeHostCmd, 0)
	for _, row := range rows {
		item := model.NeHostCmd{}
		for key, value := range row {
			if keyMapper, ok := r.resultMap[key]; ok {
				repo.SetFieldValue(&item, keyMapper, value)
			}
		}
		arr = append(arr, item)
	}
	return arr
}

// SelectPage 根据条件分页查询字典类型
func (r *NeHostCmdImpl) SelectPage(query map[string]any) map[string]any {
	// 查询条件拼接
	var conditions []string
	var params []any
	if v, ok := query["cmdType"]; ok && v != "" {
		conditions = append(conditions, "cmd_type = ?")
		params = append(params, strings.Trim(v.(string), " "))
	}
	if v, ok := query["groupId"]; ok && v != "" {
		conditions = append(conditions, "group_id = ?")
		params = append(params, strings.Trim(v.(string), " "))
	}
	if v, ok := query["title"]; ok && v != "" {
		conditions = append(conditions, "title like concat(?, '%')")
		params = append(params, strings.Trim(v.(string), " "))
	}

	// 构建查询条件语句
	whereSql := ""
	if len(conditions) > 0 {
		whereSql += " where " + strings.Join(conditions, " and ")
	}

	result := map[string]any{
		"total": 0,
		"rows":  []model.NeHost{},
	}

	// 查询数量 长度为0直接返回
	totalSql := "select count(1) as 'total' from ne_host_cmd"
	totalRows, err := datasource.RawDB("", totalSql+whereSql, params)
	if err != nil {
		logger.Errorf("total err => %v", err)
		return result
	}
	total := parse.Number(totalRows[0]["total"])
	if total == 0 {
		return result
	} else {
		result["total"] = total
	}

	// 分页
	pageNum, pageSize := repo.PageNumSize(query["pageNum"], query["pageSize"])
	pageSql := " limit ?,? "
	params = append(params, pageNum*pageSize)
	params = append(params, pageSize)

	// 查询数据
	querySql := r.selectSql + whereSql + pageSql
	results, err := datasource.RawDB("", querySql, params)
	if err != nil {
		logger.Errorf("query err => %v", err)
		return result
	}

	// 转换实体
	result["rows"] = r.convertResultRows(results)
	return result
}

// SelectList 根据实体查询
func (r *NeHostCmdImpl) SelectList(neHostCmd model.NeHostCmd) []model.NeHostCmd {
	// 查询条件拼接
	var conditions []string
	var params []any
	if neHostCmd.CmdType != "" {
		conditions = append(conditions, "cmd_type = ?")
		params = append(params, neHostCmd.CmdType)
	}
	if neHostCmd.GroupID != "" {
		conditions = append(conditions, "group_id = ?")
		params = append(params, neHostCmd.GroupID)
	}
	if neHostCmd.Title != "" {
		conditions = append(conditions, "title like concat(?, '%')")
		params = append(params, neHostCmd.Title)
	}

	// 构建查询条件语句
	whereSql := ""
	if len(conditions) > 0 {
		whereSql += " where " + strings.Join(conditions, " and ")
	}

	// 查询数据
	querySql := r.selectSql + whereSql + " order by update_time asc "
	results, err := datasource.RawDB("", querySql, params)
	if err != nil {
		logger.Errorf("query err => %v", err)
	}

	// 转换实体
	return r.convertResultRows(results)
}

// SelectByIds 通过ID查询
func (r *NeHostCmdImpl) SelectByIds(cmdIds []string) []model.NeHostCmd {
	placeholder := repo.KeyPlaceholderByQuery(len(cmdIds))
	querySql := r.selectSql + " where cmd_id in (" + placeholder + ")"
	parameters := repo.ConvertIdsSlice(cmdIds)
	results, err := datasource.RawDB("", querySql, parameters)
	if err != nil {
		logger.Errorf("query err => %v", err)
		return []model.NeHostCmd{}
	}
	// 转换实体
	return r.convertResultRows(results)
}

// CheckUniqueGroupTitle 校验同类型组内是否唯一
func (r *NeHostCmdImpl) CheckUniqueGroupTitle(neHostCmd model.NeHostCmd) string {
	// 查询条件拼接
	var conditions []string
	var params []any
	if neHostCmd.CmdType != "" {
		conditions = append(conditions, "cmd_type = ?")
		params = append(params, neHostCmd.CmdType)
	}
	if neHostCmd.GroupID != "" {
		conditions = append(conditions, "group_id = ?")
		params = append(params, neHostCmd.GroupID)
	}
	if neHostCmd.Title != "" {
		conditions = append(conditions, "title = ?")
		params = append(params, neHostCmd.Title)
	}

	// 构建查询条件语句
	whereSql := ""
	if len(conditions) > 0 {
		whereSql += " where " + strings.Join(conditions, " and ")
	} else {
		return ""
	}

	// 查询数据
	querySql := "select host_id as 'str' from ne_host " + whereSql + " limit 1"
	results, err := datasource.RawDB("", querySql, params)
	if err != nil {
		logger.Errorf("query err %v", err)
		return ""
	}
	if len(results) > 0 {
		return fmt.Sprint(results[0]["str"])
	}
	return ""
}

// Insert 新增信息
func (r *NeHostCmdImpl) Insert(neHostCmd model.NeHostCmd) string {
	// 参数拼接
	params := make(map[string]any)
	if neHostCmd.CmdType != "" {
		params["cmd_type"] = neHostCmd.CmdType
	}
	if neHostCmd.GroupID != "" {
		params["group_id"] = neHostCmd.GroupID
	}
	if neHostCmd.Title != "" {
		params["title"] = neHostCmd.Title
	}
	if neHostCmd.Command != "" {
		params["command"] = neHostCmd.Command
	}
	if neHostCmd.Remark != "" {
		params["remark"] = neHostCmd.Remark
	}
	if neHostCmd.CreateBy != "" {
		params["create_by"] = neHostCmd.CreateBy
		params["create_time"] = time.Now().UnixMilli()
	}

	// 构建执行语句
	keys, placeholder, values := repo.KeyPlaceholderValueByInsert(params)
	sql := "insert into ne_host_cmd (" + strings.Join(keys, ",") + ")values(" + placeholder + ")"

	db := datasource.DefaultDB()
	// 开启事务
	tx := db.Begin()
	// 执行插入
	err := tx.Exec(sql, values...).Error
	if err != nil {
		logger.Errorf("insert row : %v", err.Error())
		tx.Rollback()
		return ""
	}
	// 获取生成的自增 ID
	var insertedID string
	err = tx.Raw("select last_insert_id()").Row().Scan(&insertedID)
	if err != nil {
		logger.Errorf("insert last id : %v", err.Error())
		tx.Rollback()
		return ""
	}
	// 提交事务
	tx.Commit()
	return insertedID
}

// Update 修改信息
func (r *NeHostCmdImpl) Update(neHostCmd model.NeHostCmd) int64 {
	// 参数拼接
	params := make(map[string]any)
	if neHostCmd.CmdType != "" {
		params["cmd_type"] = neHostCmd.CmdType
	}
	if neHostCmd.GroupID != "" {
		params["group_id"] = neHostCmd.GroupID
	}
	if neHostCmd.Title != "" {
		params["title"] = neHostCmd.Title
	}
	if neHostCmd.Command != "" {
		params["command"] = neHostCmd.Command
	}
	params["remark"] = neHostCmd.Remark
	if neHostCmd.UpdateBy != "" {
		params["update_by"] = neHostCmd.UpdateBy
		params["update_time"] = time.Now().UnixMilli()
	}

	// 构建执行语句
	keys, values := repo.KeyValueByUpdate(params)
	sql := "update ne_host_cmd set " + strings.Join(keys, ",") + " where cmd_id = ?"

	// 执行更新
	values = append(values, neHostCmd.CmdID)
	rows, err := datasource.ExecDB("", sql, values)
	if err != nil {
		logger.Errorf("update row : %v", err.Error())
		return 0
	}
	return rows
}

// DeleteByIds 批量删除信息
func (r *NeHostCmdImpl) DeleteByIds(cmdIds []string) int64 {
	placeholder := repo.KeyPlaceholderByQuery(len(cmdIds))
	sql := "delete from ne_host_cmd where cmd_id in (" + placeholder + ")"
	parameters := repo.ConvertIdsSlice(cmdIds)
	results, err := datasource.ExecDB("", sql, parameters)
	if err != nil {
		logger.Errorf("delete err => %v", err)
		return 0
	}
	return results
}
